#include <string.h>
#include <stdlib.h>
#include <pi/pi.h>

static int try_break(char *str, int w)
{
	int pos = 0, lines = 0;
	char *last = 0;
	
	while (*str) {
		if (pos >= w || *str == '\n') {
			if (*str != '\n' && last) 
				str = last;
			/* FIXME: we loose one char for long lines */ 
			*str++ = '\n';
			last = 0;
			pos = 0;
			lines++;
		} else {
			if (*str == ' ' || *str == '\t')
				last = str;
			str++;
			pos++;
		}
	}

	return lines;
}

/* try to break words in optimal way, width is maximal allowed width. */
struct pi_wordbreak_res *pi_wordbreak(const char *string, int width)
{
	char *work, **p;
	int lines, size;
	struct pi_wordbreak_res *res;

	if (width < 0) {
		/* forced */
		width = -width;
		work = strdup(string);
		lines = try_break(work, width);
	} else 
		for (;;) {
			work = strdup(string);
			lines = try_break(work, width);
			/* optimal : lines = width / 4 */
			if (lines >= width / 4 || width <= 30) 
				break;
			width--;
			free(work);
		}

	size = sizeof(*res) + (lines + 2) * sizeof(char*);
	
	res = malloc(size + strlen(work) + 1);
	res->lines = (char**)(res + 1);
	res->nlines = 0;
	res->width = width;
	strcpy((char*)res + size, work);
	free(work);
	work = (char*)res + size;
	p = res->lines;

	while (*work) {
		*p++ = work;
		res->nlines++;
		while (*work && *work != '\n')
			work++;
		if (*work == '\n')
			*work++ = 0;
	}
	*p = 0;

	return res;
}
