#ifndef _SERVER_DB_H__
#define _SERVER_DB_H__

#include "../mess.h"

/* internal
PGresult *doQuery(PGconn *conn, char *query);
PGresult *query(PGconn *conn, const char *fmt, ...);
*/

int registerUser(char *nick, char *name, char *email,
		int experienceLevel, char *pass);
int registerMachine(char *name, int uid);
int getMachineId(char *name, int uid);
int getFeature(char *desc, int approved);
int addNewFeature(int userNo, char *featureDescription);
void addFeatureToPackage(int userNo, int featureNo, int packageNo);
int getPackageID(char *name);
int getArchID(char *name);
int addReport(int machineNo, TpkgDescribe *package, int enviromentCount, 
		TpkgDescribe *enviroment, int gradesCount, Tgrade *grades);

Tgrade* getReport(char *name, char *evr, char *arch, int *amount, int mid);
int* getPackagesFeatures(char *pkgName);
char* getFeatureName(int IDfeature);
int getMaxFeatureID(int approvedLevel);
char ** getPackagesForStatistic(char *pkg,int *count);
int *getStatistic(TpkgDescribe *pkg,TpkgDescribe *env,int featureID);
void serverOpenDB();
void serverCloseDB();
char *getPassword(int user_id);
char *getEmail(int user_id);
int getUid(char *email);
void getMachines(char ***name, int **id, int *count, int uid);
char ** getPackagesFromTest(int *count, char ***retEvr);
void getDists(char ***name, int **id, int *count);
void getCathegory(char ***name, int **id, int *count);
char ** getPackagesFromDist(int *count, char ***retEvr, int distId);

	/* user description. most of it isn't used yet */
struct user {
	struct user *next;

	int user_no;
	int machine_no;
	char *access;
	char *why_killed;
	char *cookie;
	int fd;
};

/* remove user */
void kill_user(struct user *u);

#define MYLOG(a) printf a

void handle_user(struct user *u);

/* this also needs to be written :) */
int capable(struct user *u, int cap);

/* user capabilities : */
enum {
cap_auth = 0,		/* user is authenticated */
cap_change_pkgs = 'p',	/* if user can update pakgages descriptions */
};

#endif
